#! /usr/bin/env python
import sys, os, inspect
currentdir = os.path.dirname(os.path.abspath(inspect.getfile(inspect.currentframe())))
parentdir = os.path.dirname(currentdir)
sys.path.insert(0,parentdir)
from server import *
import json

from flask import Flask, render_template, redirect, url_for, Response, request, jsonify, send_file
from flask_cors import CORS, cross_origin
from time import sleep,time
from werkzeug.contrib.fixers import ProxyFix
import io
import picamera
import subprocess

app = Flask(__name__)
CORS(app)

class sig:
    camera = None
    still_stream = None

def shutdown_server():
    func = request.environ.get('werkzeug.server.shutdown')
    if not func is None:
        func()
    Signal.serv.close_request()
    sleep(0.5)
    Signal.serv.close()

@app.route('/')
def homepage():
    return render_template('index_bs.html')

@app.route('/video_surveillance')
def video_sur():
    sig.detach=False
    return render_template('video_surveillance_bs.html')
    
@app.route('/control')
def control():
    return render_template('control.html')
                    
@app.route('/_update', methods = ['GET', 'POST'])
def list_update():
    # on control page, update retrieves all the info for the sensors
    if 'type' in request.form.keys() and request.form['type'].encode('ascii', 'ignore') == "load":
        ids = request.form['attributes'].split(',')
        res = {}
        for i in range(len(ids)):
            ids[i] = ids[i].encode('ascii', 'ignore')
            update_param("get_"+ids[i], '0')
            poll_until_update_name(ids[i], 1024)
            res[ids[i]] = Signal.serv.get_update(ids[i]+'_status')
        print res
        return json.dumps(res)
    # send all the logs
    res = []
    f = open("activity.log", "r")
    f.seek(0)
    for line in f:
        arr = line.split("$")
        if len(arr) == 3:
            res = [{"time": arr[0],"event": arr[1],"detail": arr[2][:-1]}] + res
    #print res
    f.close()
    return json.dumps(res)
   
@app.route('/_control', methods = ['GET', 'POST'])
def param_control():
    t = request.form['type'].encode('ascii','ignore')
    val = request.form['value'].encode('ascii','ignore')
    update_param(t, val)
    poll_until_update_name(t, 99999)
    sleep(0.4)
    print t, Signal.serv.get_update(t+"_status")
    return jsonify(status=Signal.serv.get_update(t+"_status"))
    
@app.route('/_camera_ctrl', methods=['GET','POST'])
def camera_ctrl():
    t="snapshot"
    #update_param(t, "0")
    #poll_until_update_name(t, 99999)
    subprocess.Popen("wget http://localhost:8080/?action=snapshot -O ~/final/Server/capture.jpg", shell=True)
    sleep(0.5)
    filename = "capture.jpg"
    return send_file(filename, mimetype="image/jpeg")

@app.route('/shutdown', methods=['POST','GET'])
def shutdown():
    shutdown_server()
    return 'Server shutting down...'

app.wsgi_app = ProxyFix(app.wsgi_app)

if __name__ == '__main__':
    # initialize message host
    init_server()
    
    # start camera
    #sig.camera = picamera.PiCamera()
    #sig.camera.resolution = (320,240)
    #sig.still_stream = io.BytesIO()
    
    # run the server
    app.run(host='0.0.0.0', debug=False, threaded=True)
