#! /bin/bash

if pgrep pigpiod
then
	echo 'got daemon running'
else
	pigpiod
fi

if pgrep mjpg_streamer > /dev/null
then
	echo 'mjpg_streamer already running'
else
	LD_LIBRARY_PATH=/home/pi/mjpg-streamer/mjpg-streamer-experimental
	mjpg_streamer -o 'output_http.so -w ./www' -i 'input_raspicam.so -fps 25 -x 640 -y 480 -q 65 -hf -sh 25 -vs' &
fi

python ../message.py &
sleep 1
python ../led_controller.py &
python ../servo_controller.py &
python ../buttons.py &
python ../security_center.py &
python run.py

if pgrep mjpg_streamer
then
	kill $(pgrep mjpg_streamer) > /dev/null 2>&1
	echo 'mjpg_streamer stopped'
else
	echo 'mjpg_streamer not running'
fi

if pgrep python
then
	killall python
	echo 'python process killed'
fi
