import socket
from client import *
from time import sleep
import RPi.GPIO as GPIO

class Signal:
    enabled = False
    events = []

def button_callback(channel):
    Signal.events.append(channel)

class ButtonPress(Client):
    button_list = {}

    def __init__(self, type, button_list):
        Client.__init__(self, type)
        for key, value in button_list.iteritems():
            self.button_list[key] = value
            GPIO.setup(key, GPIO.IN)
            GPIO.add_event_detect(key, GPIO.FALLING, callback=button_callback, bouncetime=300)
        
    def resolve_msg(self, msg):
        Client.resolve_msg(self, msg)

    def handle_event(self, channel):
        self.send_status_update(self.button_list[channel])

    def send_status_update(self, name):
        if len(self.network) != 0:
            s = self.construct_update(self.network, name, "pressed")
            self.send(s)

    def _resolve_update_msg(self, name, payload):
        debug_print("resolve update msg: ", name, payload)

    def close(self):
        Client.close(self)
        GPIO.cleanup()

port = 12345
host = socket.gethostname()
GPIO.setmode(GPIO.BCM)

button_list = {15: 'front_door_btn',14: 'balcony_btn'}
ctrl = ButtonPress('button_ctrl', button_list)
ctrl.init_connections(port, host)

count = 0
while(not ctrl.closed):
    sleep(0.2)
    ctrl.poll_msg([ctrl.server],[],[])
    ctrl.update_network()
    while (len(Signal.events) != 0):
        ctrl.handle_event(Signal.events.pop())