import socket
from client import *
from time import sleep
import RPi.GPIO as GPIO

class Signal():
    connected = False
    initiated = False

class LightingCtrl(Client):
    lighting_control_list = {}
    pin_list = {}

    def __init__(self, type, pin_list):
        Client.__init__(self, type)
        for key, value in pin_list.iteritems():
            self.lighting_control_list[key] = 0
            self.pin_list[key] = int(pin_list[key])
            GPIO.setup(self.pin_list[key], GPIO.OUT)
            GPIO.output(self.pin_list[key], 0)
        
    def resolve_msg(self, msg):
        Client.resolve_msg(self, msg)

    def send_status_update(self, name, payload):
        if len(self.network) != 0:
            s = self.construct_update(self.network, name+'_status', str(payload))
            self.send(s)

    def _resolve_update_msg(self, name, payload):
        debug_print("resolve update msg: ", name, payload)
        if "get_" in name:
            if name[4:] in self.lighting_control_list.keys():
                self.send_status_update(name[4:], self.lighting_control_list[name[4:]])
        if name in self.lighting_control_list.keys():
            self.set_light(name, payload)

    def set_light(self, name, payload):
        self.lighting_control_list[name] = 1 if payload == "true" else 0
        self.ctrl_led()
        self.send_status_update(name, payload)

    def ctrl_led(self):
        for key, value in self.lighting_control_list.iteritems():
            GPIO.output(self.pin_list[key], int(value))

    def close(self):
        Client.close(self)
        GPIO.cleanup()




port = 12345
host = socket.gethostname()
GPIO.setmode(GPIO.BCM)
#lighting_control_list = {'bedroom_light_1' : 5, 'bedroom_light_2' : 6, 'dining_room_light_1' : 13}
lighting_control_list = {'bedroom_light_1': 5,'bedroom_light_2': 6, 'living_room_light_1' : 13, 'dining_room_light_1' : 26}
ctrl = LightingCtrl('led_ctrl', lighting_control_list)
ctrl.init_connections(port, host)

count = 0
while(not ctrl.closed):
    sleep(0.2)
    ctrl.poll_msg([ctrl.server],[],[])
    ctrl.update_network()
    #if ctrl.initiated:
        #ctrl.set_led()
        #ctrl.send_update_led()
