import socket
from client import *
from time import sleep
import select
import sys
import errno

class Terminal:
    uid = 0
    node = None
    addr = None
    terminal_type = ''
    input_buffer = ''
    output_buffer = ''

    def __init__(self, terminal_type = 'unknown'):
        pass

class MessageServer(Message):
    terminals = {}
    running = {}
    unknown = []
    buf = {}
    connected = False
    run = False
    try_initiate = False
    messenger_type = 'msg_server'
    closed = False

    def __init__(self, *args):
        for arg in args:
            if type(arg) is str:
                self.terminals[arg] = None
                self.running[arg] = None
                self.buf[arg] = None


# ========== message handler end =================

    def _set_client(self, client, name):
        found = False
        for key in self.terminals.keys():
            key_word = "/{}/".format(key.strip())
            debug_print("MessageServer set client: ", key_word)
            debug_print("MessageServer set client: name: ", name)
            if name.find(key_word)!=-1:
                self.terminals[key] = client
                self.unknown.remove(client)
                debug_print('MessageServer set client: connected to', key)
                found = True
        if not found:
            debug_print("MessageServer set client: Unresolved cleint name!")
            return
        connect_flag = True
        for v in self.terminals.values():
            if v is None:
                connect_flag = False
        self.connected = connect_flag
        # try to initiate system if system not running and try initiate flag set true
        if (self.connected and not self.run and self.try_initiate):
            self.send_to_all('I')
            debug_print('MessageServer set client: init system')

    def _try_run(self, client, name):
        found = False
        for key in self.terminals.keys():
            key_word = "/{}/".format(key.strip())
            debug_print(key_word)
            debug_print("MessageServer try run ","name: ", name)
            if name.find(key_word)!=-1:
                self.running[key] = client
                debug_print("MessageServer try run ",'client', key, 'sends initialization feedback')
                found = True
                break
        if not found:
            debug_print("MessageServer try run ","Unresolved cleint name!")
            return
        running_flag = True
        for v in self.running.values():
            if v == None:
                running_flag = False
        self.run = running_flag
        if self.run:
            self.try_initiate == False

    def _resolve_msg(self, client, msg):
        #print "resolving message... " + msg
        if msg == '':
            return
        Message._resolve_msg(self,client, msg)
        if msg[0] == 'T':
            debug_print("MessageServer resolve msg ",'received type from client')
            self._set_client(client, msg[1:])
        if msg[0] == 'I':
            debug_print("MessageServer resolve msg ",'received initiate response from client')
            self._try_run(client, msg[1:])
        if msg[0] == 'U':
            debug_print ("MessageServer resolve msg ",'update')
            name = self.update_msg(msg[1:])
            #debug_print(name)
            if name in self.update_msg_list.keys():
                self.forward(self.update_msg_list[name].dest, msg)
        if msg[0] == 'X':
            for v in self.terminals:
                print v
                if (msg[2:] != v):
                    self.terminals[v].send('X\n')
                    self.terminals[v].shutdown(socket.SHUT_RDWR)
            self.close()

    def close(self):
        self.sock.close()
        self.closed = True


# ========== message handler end =================

    def send_to_all(self, s):
        if not type(s) is str:
            return
        for v in self.get_terminal_list():
            v.send(s+'\n')

    def try_accept(self):
        c, addr = self.sock.accept()
        debug_print("MessageServer try accept: ",'Got connection from ', addr)
        c.setblocking(0)
        self.unknown.append(c)
        c.send('T\n')
        debug_print("MessageServer try accept: ", "sending'T'")

    def init_connections(self, port):
        # Init socket
        self.sock = socket.socket()
        self.host = socket.gethostname()
        self.port = port
        debug_print("MessageServer init connections: ", 'host name: ' + self.host)
        self.sock.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
        self.sock.bind((self.host, self.port))
        # set the socket nonblocking
        self.sock.setblocking(0)
        # Listen on the socket
        self.sock.listen(3)
        self.try_initiate = True

    def send(self, name, msg):
        self.terminals[name].send(msg+'\n')

    def get_terminal_list(self):
        return [v for v in msg.terminals.values() if not v is None]

    def get_type_list(self):
        return [k for k, v in msg.terminals.iteritems() if not v is None]

    def set_nonblocking_all(self):
        for v in self.terminals.values():
            v.setblocking(0)

    def forward(self, dest_list, msg):
        for d in dest_list:
            if d != self.messenger_type:
                self.send(d, msg)

    def update_network(self):
        l = self.get_type_list()
        if len(l) == 0:
            return
        p = ';'.join(l)
        s = self.construct_update(l, 'network', p)
        for n in l:
            self.send(n, s)

msg = MessageServer('led_ctrl', 'servo_ctrl', 'button_ctrl', 'server', 'security_center')
msg.init_connections(12345)


while(not msg.closed):
    sleep(0.1)
    terminal_list = msg.get_terminal_list()
    terminal_list.append(msg.sock)
    terminal_list.extend(msg.unknown)
    readable, writable, exceptional = select.select(terminal_list, [], [], 0)
    for s in readable:
        # accept connection from serving socket
        if s is msg.sock:
            msg.try_accept()
        # read data from other socket readable
        else:
            msg.recv(s)
    if not msg.run:
        msg.update_network()
