import socket
from client import *
from time import sleep, time

class Signal:
    serv = None

class Server(Client):
    def resolve_msg(self, msg):
        Client.resolve_msg(self, msg)

    def set_led(self, name, x):
        s = self.construct_update(self.network, name, str(x))
        self.send(s)

def init_server():
    port = 12345
    host = socket.gethostname()
    Signal.serv = Server('server')
    Signal.serv.init_connections(port, host)
    print Signal.serv
    while (not Signal.serv.initiated):
        Signal.serv.poll_msg([Signal.serv.server],[],[])
        Signal.serv.update_network()
    print "initiation successful"

def toggleLED(name, status):
    Signal.serv.poll_msg([Signal.serv.server],[],[])
    Signal.serv.update_network()
    Signal.serv.set_led(name, status)

def getLED():
    Signal.serv.poll_msg([Signal.serv.server],[],[])
    Signal.serv.update_network()
    return Signal.serv.get_update('led')
    
def update_param(name, value):
    Signal.serv.poll_msg([Signal.serv.server],[],[])
    Signal.serv.update_network()
    s = Signal.serv.construct_update(Signal.serv.network, name, str(value))
    Signal.serv.send(s)

def poll_until_update_name(name, timeout):
    name = name + "_status"
    start = time()
    time_now = start
    # if name not updated before
    if not name in Signal.serv.update_msg_list.keys():
        while (not name in Signal.serv.update_msg_list.keys()) :
            # poll message
            Signal.serv.poll_msg([Signal.serv.server],[],[])
            Signal.serv.update_network()
            # name added to list
            if name in Signal.serv.update_msg_list.keys():
                return Signal.serv.get_update(name)
            # check time out
            time_now = time()
            if (time_now - start)*1000 > timeout:
                print 'time out: ', (time_now - start)*1000
                return None
    # if name has been updated before, check update version before poll
    v = Signal.serv.update_msg_list[name].version
    # if version changes, will not enter loop
    while (Signal.serv.update_msg_list[name].version == v):
        # poll message
        Signal.serv.poll_msg([Signal.serv.server],[],[])
        Signal.serv.update_network()
        # check time out
        time_now = time()
        if (time_now - start)*1000 > timeout:
            print 'time out: ', (time_now - start)*1000
            return None
    return Signal.serv.get_update(name)

def poll_until_update_names(names, timeout):
    start = time()
    time_now = start
    v_list = {}
    # generate a list to keep track of the versioning of the wanted updates
    for i in names:
        i = i + "_status"
        if not i in Signal.serv.update_msg_list.keys():
            # if not updated before
            v_list[i] = None
        else:
            v_list[i] = Signal.serv.update_msg_list[i].version
    # then we start polling until all the versioning has been updated
    # when all the entries is different from the current version list, exit loop
    cond = False
    while (not cond):
        # poll
        Signal.serv.poll_msg([Signal.serv.server],[],[])
        Signal.serv.update_network()
        # check timeout
        time_now = time()
        if (time_now - start)*1000 > timeout:
            print 'time out: ', (time_now - start)*1000
            return False
        exit_cond = True
        for i in names:
            i = i + "_status"
            if not i in Signal.serv.update_msg_list.keys():
                exit_cond = False
                break
            if v_list[i] == Signal.serv.update_msg_list[i].version:
                exit_cond = False
        cond = exit_cond
    return True
